
/*
 * Author - Mahesh Subramanyan
 *        - Miguel del Rosario
 *        - Marek Podgorny
 *          NPAC, Syracuse University
 *
 * Read "n" bytes from a descriptor.
 * Use in place of read() when fd is a stream socket.
 */

#define BLOCK_SIZE 32768

int readn(fd, ptr, nbytes)
     int  fd;
     char *ptr;
     int  nbytes;
{
  int nleft, nread, ntemp;
  
  nleft = nbytes;
  while ( nleft > 0 ) {

    if (nleft > 32768)
      ntemp = 32768;
    else
      ntemp = nleft;

    nread = read(fd, ptr, ntemp);
    if ( nread < 0 ) return(nread);
    else if ( nread == 0 ) break;
    nleft -= nread;
    ptr   += nread;
  }
  return(nbytes-nleft);

}

/*
 * Write "n" bytes to a descriptor.
 * Use in place of write() when fd is a stream socket.
 */

int writen(fd, ptr, nbytes)
     int  fd;
     char *ptr;
     int  nbytes;
{
  int nleft, nwritten;
  int nit;
  
  nit = nbytes/BLOCK_SIZE;
  nleft = nbytes - (nit * BLOCK_SIZE);
  while (nit) {
    nwritten = write(fd, ptr, BLOCK_SIZE);
    if ( nwritten < 0 ) return(nwritten);
    nit--;
    ptr += nwritten;
  }
  if (nleft > 0)
    nwritten = write(fd, ptr, nleft);
  return(nbytes);

}
